###############################################################################
#                                                                             #
# Settings_MemberMap.pm  by XTC                                               #
#                                                                             #
###############################################################################
#                                                                             #
# Version:        Beta 2				                      #
# Date:           01 / 2015                                                   #
# Distributed by: http://www.xonder.com/cgi-bin/yabb26/YaBB.pl                #
#                                                                             #
# =========================================================================== #
#                                                                             #
# NOTE: Goggle Maps is a registered trademark of Google Inc.                  #
#       The author declines every responsability about this software          #
#                                                                             #
# =========================================================================== #
#                                                                             #
# Copyright (c) 2015 ..::X.T.C::....M.o.d.s::.. - All Rights Reserved.        #
#       The author declines every responsability about this software          #
#                                                                             #
###############################################################################

$settings_membermappmver = 'MemberMap Mod Beta2';
if ( $action eq 'detailedversion' ) { return 1; }

# Language requirements
LoadLanguage('Register');
LoadLanguage("MemberMap");

    if ($minClusterSize eq q{}) { $minClusterSize = 3; }
    if ($gridSize eq q{}) { $gridSize = 10; } #px
    if ($MapTypeId eq q{}) { $MapTypeId = 'ROADMAP';}
    if ($MapTypeControlStyle eq q{}) { $MapTypeControlStyle = 'HORIZONTAL_BAR';}

# List of settings
@settings = (
{
    name  => $map_txt{'membermap'},
    id    => 'membermap',
    items => [
        {
            header => $mapadmin_txt{'membermapset'},
        },
        {
            description => qq~$mapadmin_txt{'show'}~,
            input_html => qq~
<select name="Show_MemberMap" id="Show_MemberMap" size="1">
 <option value="0"${isselected($Show_MemberMap == 0)}>$userlevel_txt{'none'}</option>
 <option value="1"${isselected($Show_MemberMap == 1)}>$userlevel_txt{'members'}</option>
 <option value="2"${isselected($Show_MemberMap == 2)}>$userlevel_txt{'all'}</option>
</select>
~,
            name => 'Show_MemberMap',
            validate => 'number',
        },
        {
            description => qq~<label for="Map_on_Reg">$mapadmin_txt{'Map_on_Reg'}</label>~,
            input_html => qq~
<select name="Map_on_Reg" id="Map_on_Reg" size="1">
 <option value="0">$register_txt{'771'}</option>
 <option value="1"${isselected($Map_on_Reg == 1)}>$register_txt{'772'}</option>
 <option value="2"${isselected($Map_on_Reg == 2)}>$register_txt{'773'}</option>
</select>~,
            name => 'Map_on_Reg',
            validate => 'number,null',
            depends_on => ['Show_MemberMap!=0'],
        },
        {
            description =>
qq~<label for="membermapTab">$mapadmin_txt{'membermapTab'}</label>~,
            input_html =>
qq~<input type="checkbox" name="membermapTab" id="membermapTab" value="1"${ischecked($membermapTab)} />~,
            name     => 'membermapTab',
            validate => 'boolean',
            depends_on => ['Show_MemberMap!=0'],
        },
        {
            description => qq~<label for="user_Hide_Map">$mapadmin_txt{'mapThreads'}</label>~,
            input_html => qq~<input type="checkbox" name="mapThreads" id="mapThreads" value="1"${ischecked($mapThreads)} />~,
            name => 'mapThreads',
            validate => 'boolean',
            depends_on => ['Show_MemberMap!=0'],
        },
        {
            description => qq~<label for="user_Hide_Map">$mapadmin_txt{'memberhideMap'}</label>~,
            input_html => qq~<input type="checkbox" name="user_Hide_Map" id="user_Hide_Map" value="1"${ischecked($user_Hide_Map)} />~,
            name => 'user_Hide_Map',
            validate => 'boolean',
            depends_on => ['Show_MemberMap!=0','mapThreads'],
        },
        {
            header => $mapadmin_txt{'membermapStyleset'},
        },
        {
            description => qq~$mapadmin_txt{'mapstyle'}~,
            input_html => qq~
<select name="MapTypeId" id="MapTypeId" size="1">
 <option value="ROADMAP"${isselected($MapTypeId eq 'ROADMAP')}>$mapadmin_txt{'ROADMAP'}</option>
 <option value="SATELLITE"${isselected($MapTypeId eq 'SATELLITE')}>$mapadmin_txt{'SATELLITE'}</option>
 <option value="HYBRID"${isselected($MapTypeId eq 'HYBRID')}>$mapadmin_txt{'HYBRID'}</option>
 <option value="TERRAIN"${isselected($MapTypeId eq 'TERRAIN')}>$mapadmin_txt{'TERRAIN'}</option>
</select>
~,
            name => 'MapTypeId',
            validate => 'text',
        },
        {
            description => $mapadmin_txt{'maptypestyle'},
            input_html => qq~
<select name="MapTypeControlStyle" id="MapTypeControlStyle" size="1">
 <option value="DEFAULT"${isselected($MapTypeControlStyle eq 'DEFAULT')}>$mapadmin_txt{'DEFAULT'}</option>
 <option value="HORIZONTAL_BAR"${isselected($MapTypeControlStyle eq 'HORIZONTAL_BAR')}>$mapadmin_txt{'HORIZONTAL_BAR'}</option>
 <option value="DROPDOWN_MENU"${isselected($MapTypeControlStyle eq 'DROPDOWN_MENU')}>$mapadmin_txt{'DROPDOWN_MENU'}</option>
</select>
~,
            name => 'MapTypeControlStyle',
            validate => 'text',
        },
        {
            description => qq~$mapadmin_txt{'ZoomControlStyle'}<br /><span class="small">$mapadmin_txt{'ZoomControlStyleInfo'}</span>~,
            input_html => qq~<input type="checkbox" name="ZoomControlStyle" value="1"${ischecked($ZoomControlStyle)} />~,
            name => 'ZoomControlStyle',
            validate => 'boolean',
        },
        {
            description => qq~$mapadmin_txt{'ColorLinks'}<br /><span class="small">$mapadmin_txt{'ColorLinksInfo'}</span>~,
            input_html => qq~<input type="checkbox" name="Map_ColorLinks" value="1"${ischecked($Map_ColorLinks)} />~,
            name => 'Map_ColorLinks',
            validate => 'boolean',
        },
        {
            description => qq~$mapadmin_txt{'MarkerAnimation'}~,
            input_html => qq~
<input type="radio" value="0"${ischecked(!$MarkerAnimation)} name="MarkerAnimation"> $mapadmin_txt{'MarkerAnimation_a'} 
<input type="radio" value="1"${ischecked($MarkerAnimation)} name="MarkerAnimation"> $mapadmin_txt{'MarkerAnimation_b'}
~,
            name => 'MarkerAnimation',
            validate => 'boolean',
        },
        {
            header => $mapadmin_txt{'MarkerClustererset'},
        },
        {
            description => qq~$mapadmin_txt{'MarkerClusterer'}<br /><span class="small">$mapadmin_txt{'MarkerClustererInfo'}~,
            input_html => qq~<input type="checkbox" name="MarkerClusterer" value="1"${ischecked($MarkerClusterer)} />~,
            name => 'MarkerClusterer',
            validate => 'boolean',
        },
        {
            description => qq~$mapadmin_txt{'ClusterSize'}<br /><span class="small">$mapadmin_txt{'ClusterSizeInfo'}~,
            input_html => qq~<input type="text" maxlength="3" size="3" name="minClusterSize" value="$minClusterSize" />~,
            name => 'minClusterSize',
            validate => 'number',
        },
        {
            description => qq~$mapadmin_txt{'gridSize'}<br /><span class="small">$mapadmin_txt{'gridSizeInfo'}</span>~,
            input_html => qq~<input type="text" maxlength="3" size="3" name="gridSize" value="$gridSize" /> $mapadmin_txt{'pixel'}~,
            name => 'gridSize',
            validate => 'number',
        },
    ],
},
{
    name  => $mapadmin_txt{'RebuildMap'},
    id    => 'gallheader',
    items => [
        {
            header => $mapadmin_txt{'RebuildMap'},
        },
        {
            description =>
qq~<label for="RebuildMap">$mapadmin_txt{'RebuildMap'}:<br /><span class="small">$mapadmin_txt{'RebuildMapInfo'}</span></label>~,
            input_html =>
qq~<input type="checkbox" name="RebuildMap" id="RebuildMap" value="1" />~,
            name     => 'RebuildMap',
            validate => 'boolean',
        },
    ],
},
);



# Routine to save the MemberMap settings
sub SaveSettings {
    my %settings = @_;

# Rebuild MemberMap
if ( $settings{'RebuildMap'} == 1 ) {

        unlink "$vardir/membermap.db";

        fopen( FILE, "$memberdir/memberlist.txt" );
        @mapmembers = <FILE>;
        fclose(FILE);
        fopen( FILE, ">$vardir/membermap.db" );
        foreach my $user_map_name (@mapmembers) {
            ( $user_xy, $dummy ) = split /\t/sm, $user_map_name;
            chomp $user_xy;
            LoadUser($user_xy);

            $user_latitude      = ${ $uid . $user_xy }{'latitude'};
            $user_longitude     = ${ $uid . $user_xy }{'longitude'};
            $user_mapzoom       = ${ $uid . $user_xy }{'mapzoom'};
            $user_countryselect = ${ $uid . $user_xy }{'countryselect'};

            if ($user_latitude  || $user_latitude ) {

                if (${ $uid . $user_xy }{'maphide'}){$user_maphide = 1;}
                else {$user_maphide = q{};}
                print {FILE} qq~$user_xy|$user_latitude|$user_longitude|$user_mapzoom|$user_maphide|$user_countryselect\n~ or qq~$croak{'print'} membermap.db~;
            }
        }
        fclose(FILE);
}

# Save MemberMap Settings

   if ( $settings{'Show_MemberMap'} == 0 ) {
	$settings{'Map_on_Reg'}      = 0;
	$settings{'membermapTab'}    = 0;
	$settings{'mapThreads'}      = 0;
	$settings{'user_Hide_Map'}   = 0;  }
   if ( $settings{'mapThreads'} == 0 )     {
	$settings{'user_Hide_Map'}   = 0;  }
   if ( $settings{'gridSize'} > 100 )      {
	$settings{'gridSize'}        = 100;}

   SaveSettingsTo('Settings.pm', %settings);
    return;
}

1;
